diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index a6752ddbc..c39cf79a9 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -2,45 +2,41 @@ package net.minecraft.core.block;
 
 
 import com.b100.utils.Utils;
-import net.minecraft.core.HitResult;
+import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.block.BlockItem;
+import net.minecraft.core.sound.BlockSound;
+import net.minecraft.core.sound.BlockSounds;
+import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.block.piston.BlockPistonBase;
-import net.minecraft.core.block.piston.BlockPistonHead;
-import net.minecraft.core.block.piston.BlockPistonMoving;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IItemConvertible;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.ItemToolShears;
-import net.minecraft.core.item.block.ItemBlock;
-import net.minecraft.core.item.block.ItemBlockAlgae;
-import net.minecraft.core.item.block.ItemBlockLadder;
-import net.minecraft.core.item.block.ItemBlockLamp;
-import net.minecraft.core.item.block.ItemBlockLayerLeaves;
-import net.minecraft.core.item.block.ItemBlockPainted;
-import net.minecraft.core.item.block.ItemBlockSlabPainted;
-import net.minecraft.core.item.block.ItemBlockStairsPainted;
+import net.minecraft.core.item.ToolShearsItem;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.HashMap;
+import java.util.LinkedHashMap;
 import java.util.Map;
 import java.util.Random;
 import java.util.function.Function;
@@ -49,30 +45,76 @@ import java.util.function.Supplier;
 public class Block
     implements ITaggable<Block>, IItemConvertible
 {
-	public Block(String key, int id, Material material)
+    public static final @Nullable Block @NotNull [] blocksList = new Block[16384];
+    public static final Map<NamespaceID, Block> blockMap = new LinkedHashMap<>();
+    public static final boolean[] shouldTick = new boolean[blocksList.length];
+    public static final boolean[] solid = new boolean[blocksList.length];
+    public static final boolean[] isEntityTile = new boolean[blocksList.length];
+    public static final int[] lightBlock = new int[blocksList.length];
+    public static final boolean[] translucent = new boolean[blocksList.length];
+    public static final int[] lightEmission = new int[blocksList.length];
+    public static final boolean[] neighborNotifyOnMetadataChangeDisabled = new boolean[blocksList.length];
+    public static final Map<String, Integer> keyToIdMap = new HashMap<>();
+    public static int highestBlockId = 0;
+
+    public final int id;
+    public final NamespaceID namespaceID;
+    protected float blockHardness;
+    protected float blastResistance;
+    protected boolean blockConstructorCalled;
+    protected boolean enableStats;
+    protected boolean isLitInteriorSurface;
+    public double minX;
+    public double minY;
+    public double minZ;
+    public double maxX;
+    public double maxY;
+    public double maxZ;
+    public float blockParticleGravity;
+    public final Material blockMaterial;
+    public float friction;
+    protected String key;
+    public int dropOverride = -1;
+    public boolean immovable = false;
+    public MaterialColor overrideColor;
+    private BlockSound blockSound = BlockSounds.DEFAULT;
+
+    @Nullable
+    Supplier<@NotNull IItemConvertible> statParent = null;
+
+
+	public Block(String translationKey, String namespaceId, int id, Material material)
     {
         blockConstructorCalled = true;
         enableStats = true;
         blockParticleGravity = 1.0F;
-        movementScale = 0.6F;
+        friction = 0.6F;
         immovable = false;
         this.id = id;
-        if(blocksList[id] != null)
-        {
-            throw new IllegalArgumentException("Slot " + id + " is already occupied by " + blocksList[id] + " when adding " + this);
+        try {
+            this.namespaceID = new NamespaceID(namespaceId);
+        } catch (HardIllegalArgumentException e){
+            throw new IllegalArgumentException(e);
         }
-        else
-        {
-            blockMaterial = material;
-            blocksList[id] = this;
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            solid[id] = isSolidRender();
-            lightBlock[id] = (isSolidRender() || blocksLight()) ? 255 : 0;
-            translucent[id] = !material.blocksLight();
-            isEntityTile[id] = false;
-            setKey(key);
-            if (highestBlockId < id) highestBlockId = id;
+
+        if(blocksList[id] != null) {
+            throw new IllegalArgumentException("Block slot '" + id + "' is already occupied by '" + blocksList[id] + "' when adding " + this);
+        }
+        if (blockMap.containsKey(this.namespaceID)){
+            throw new IllegalArgumentException("Block id '" + namespaceID + "' is already used by '" + blockMap.get(this.namespaceID) + "' when adding " + this);
         }
+
+        blockMaterial = material;
+        blocksList[id] = this;
+        blockMap.put(this.namespaceID, this);
+        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+        solid[id] = isSolidRender();
+        lightBlock[id] = (isSolidRender() || blocksLight()) ? 255 : 0;
+        translucent[id] = !material.blocksLight();
+        isEntityTile[id] = false;
+        setKey(translationKey);
+
+        if (highestBlockId < id) highestBlockId = id;
     }
 
 	public Block withDisabledNeighborNotifyOnMetadataChange()
@@ -90,12 +132,12 @@ public class Block
         lightBlock[id] = blockAmount;
         return this;
     }
-
     public Block withLightEmission(float lightEmission)
     {
         Block.lightEmission[id] = (int)(15F * lightEmission);
         return this;
     }
+
     public Block withLightEmission(int lightEmission)
     {
         Block.lightEmission[id] = lightEmission & 0x0F;
@@ -114,14 +156,25 @@ public class Block
         return this;
     }
 
-    public boolean renderAsNormalBlock()
+    public Block withSound(BlockSound sound)
+    {
+        this.blockSound = sound;
+        return this;
+    }
+
+    public BlockSound getSound()
+    {
+        return blockSound;
+    }
+
+    public boolean isCubeShaped()
     {
         return true;
     }
 
     public boolean canPlaceOnSurface()
     {
-        return this.renderAsNormalBlock();
+        return this.isCubeShaped();
     }
 
     public boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z)
@@ -131,7 +184,7 @@ public class Block
 
     public boolean renderAsNormalBlockOnCondition(World world, int x, int y, int z)
     {
-        return renderAsNormalBlock();
+        return isCubeShaped();
     }
 
     public boolean canPlaceOnSurfaceOfBlock(World world, int x, int y, int z)
@@ -148,7 +201,7 @@ public class Block
         }
         return this;
     }
-    
+
     public Block setDropOverride(int dropId)
     {
     	dropOverride = dropId;
@@ -160,7 +213,6 @@ public class Block
         isLitInteriorSurface = isLit;
         return this;
     }
-
     public Block withSetUnbreakable()
     {
         withHardness(-1F);
@@ -170,17 +222,27 @@ public class Block
         this.blockItemSupplier = itemSupplier;
         return this;
     }
+
     public Block setBlockItem(@NotNull Function<Block, Item> itemSupplier){
         this.blockItemSupplier = () -> itemSupplier.apply(this);
         return this;
     }
+    public Block withOverrideColor(MaterialColor color){
+        this.overrideColor = color;
+        return this;
+    }
+
+    public Block setStatParent(@NotNull Supplier<@NotNull IItemConvertible> icon){
+        this.statParent = icon;
+        return this;
+    }
 
     public float getHardness()
     {
         return blockHardness;
     }
 
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if (dropCause != EnumDropCause.IMPROPER_TOOL)
         {
@@ -212,9 +274,9 @@ public class Block
 	public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
 		return blockAccess.getLightmapCoord(x, y, z, lightEmission[id]);
 	}
-	
+
 	/**
-	 * Used when fullbright or lightmap is active 
+	 * Used when fullbright or lightmap is active
 	 */
 	public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
 		return isSolidRender() ? 1.0f : 0.0f;
@@ -265,7 +327,7 @@ public class Block
 
     public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        return AABB.getBoundingBoxFromPool((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
+        return AABB.getTemporaryBB((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
     }
 
     public BoundingVolume getBoundingVolume(World world, int x, int y, int z)
@@ -276,12 +338,12 @@ public class Block
     public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
     {
         AABB aabbFromPool = getCollisionBoundingBoxFromPool(world, x, y, z);
-        if(aabbFromPool != null && aabb.intersectsWith(aabbFromPool))
+        if(aabbFromPool != null && aabb.intersects(aabbFromPool))
         {
             aabbList.add(aabbFromPool);
         }
     }
-    
+
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z)
     {
         return true;
@@ -289,7 +351,11 @@ public class Block
 
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        return AABB.getBoundingBoxFromPool((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
+        return AABB.getTemporaryBB((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
+    }
+    public MaterialColor getMaterialColor(){
+        if (overrideColor != null) return overrideColor;
+        return blockMaterial.color;
     }
 
     public boolean isSolidRender()
@@ -316,7 +382,7 @@ public class Block
     {
     }
 
-    public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+    public void animationTick(World world, int x, int y, int z, Random rand)
     {
     }
 
@@ -324,31 +390,28 @@ public class Block
     {
     }
 
-    public int tickRate()
+    public int tickDelay()
     {
         return 10;
     }
 
-    public void onBlockAdded(World world, int x, int y, int z)
+    public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
     }
 
-    public void onBlockAdded(EntityPlayer player, World world, int x, int y, int z)
-    {
-    }
 
     /**
-     * Always called when a block is removed by setBlock 
+     * Always called when a block is removed by setBlock
      */
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
     }
-    
+
     /**
      * Called when a block has been broken by a player, after {@link Block#onBlockRemoved(World, int, int, int, int)}
      */
-    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, EntityPlayer player, Item item) {
-    	
+    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
+
     }
 
     public boolean renderFullbright()
@@ -356,7 +419,7 @@ public class Block
         return false;
     }
 
-    public float blockStrength(EntityPlayer player)
+    public float blockStrength(Player player)
     {
         if(blockHardness < 0.0F)
         {
@@ -381,78 +444,78 @@ public class Block
         return blastResistance / 5F;
     }
 
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3d start, Vec3d end)
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
     {
         setBlockBoundsBasedOnState(world, x, y, z);
-        start = start.addVector(-x, -y, -z);
-        end = end.addVector(-x, -y, -z);
-		Vec3d vec3d2 = start.getIntermediateWithXValue(end, minX);
-		Vec3d vec3d3 = start.getIntermediateWithXValue(end, maxX);
-		Vec3d vec3d4 = start.getIntermediateWithYValue(end, minY);
-		Vec3d vec3d5 = start.getIntermediateWithYValue(end, maxY);
-		Vec3d vec3d6 = start.getIntermediateWithZValue(end, minZ);
-		Vec3d vec3d7 = start.getIntermediateWithZValue(end, maxZ);
-
-		if(!isVecInsideYZBounds(vec3d2)) vec3d2 = null;
+        start = start.add(-x, -y, -z);
+        end = end.add(-x, -y, -z);
+		Vec3 vec32 = start.clipX(end, minX);
+		Vec3 vec3d3 = start.clipX(end, maxX);
+		Vec3 vec34 = start.clipY(end, minY);
+		Vec3 vec35 = start.clipY(end, maxY);
+		Vec3 vec36 = start.clipZ(end, minZ);
+		Vec3 vec37 = start.clipZ(end, maxZ);
+
+		if(!isVecInsideYZBounds(vec32)) vec32 = null;
 		if(!isVecInsideYZBounds(vec3d3)) vec3d3 = null;
-		if(!isVecInsideXZBounds(vec3d4)) vec3d4 = null;
-		if(!isVecInsideXZBounds(vec3d5)) vec3d5 = null;
-		if(!isVecInsideXYBounds(vec3d6)) vec3d6 = null;
-		if(!isVecInsideXYBounds(vec3d7)) vec3d7 = null;
-
-		Vec3d vec3d8 = null;
-		if(vec3d2 != null && (vec3d8 == null || start.squareDistanceTo(vec3d2) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d2;
-		if(vec3d3 != null && (vec3d8 == null || start.squareDistanceTo(vec3d3) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d3;
-		if(vec3d4 != null && (vec3d8 == null || start.squareDistanceTo(vec3d4) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d4;
-		if(vec3d5 != null && (vec3d8 == null || start.squareDistanceTo(vec3d5) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d5;
-		if(vec3d6 != null && (vec3d8 == null || start.squareDistanceTo(vec3d6) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d6;
-		if(vec3d7 != null && (vec3d8 == null || start.squareDistanceTo(vec3d7) < start.squareDistanceTo(vec3d8))) vec3d8 = vec3d7;
-
-		if(vec3d8 == null) return null;
+		if(!isVecInsideXZBounds(vec34)) vec34 = null;
+		if(!isVecInsideXZBounds(vec35)) vec35 = null;
+		if(!isVecInsideXYBounds(vec36)) vec36 = null;
+		if(!isVecInsideXYBounds(vec37)) vec37 = null;
+
+		Vec3 vec38 = null;
+		if(vec32 != null && (vec38 == null || start.distanceToSquared(vec32) < start.distanceToSquared(vec38))) vec38 = vec32;
+		if(vec3d3 != null && (vec38 == null || start.distanceToSquared(vec3d3) < start.distanceToSquared(vec38))) vec38 = vec3d3;
+		if(vec34 != null && (vec38 == null || start.distanceToSquared(vec34) < start.distanceToSquared(vec38))) vec38 = vec34;
+		if(vec35 != null && (vec38 == null || start.distanceToSquared(vec35) < start.distanceToSquared(vec38))) vec38 = vec35;
+		if(vec36 != null && (vec38 == null || start.distanceToSquared(vec36) < start.distanceToSquared(vec38))) vec38 = vec36;
+		if(vec37 != null && (vec38 == null || start.distanceToSquared(vec37) < start.distanceToSquared(vec38))) vec38 = vec37;
+
+		if(vec38 == null) return null;
 		Side side = Side.NONE;
-		if(vec3d8 == vec3d2) side = Side.WEST;
-		if(vec3d8 == vec3d3) side = Side.EAST;
-		if(vec3d8 == vec3d4) side = Side.BOTTOM;
-		if(vec3d8 == vec3d5) side = Side.TOP;
-		if(vec3d8 == vec3d6) side = Side.NORTH;
-		if(vec3d8 == vec3d7) side = Side.SOUTH;
+		if(vec38 == vec32) side = Side.WEST;
+		if(vec38 == vec3d3) side = Side.EAST;
+		if(vec38 == vec34) side = Side.BOTTOM;
+		if(vec38 == vec35) side = Side.TOP;
+		if(vec38 == vec36) side = Side.NORTH;
+		if(vec38 == vec37) side = Side.SOUTH;
 
-        return new HitResult(x, y, z, side, vec3d8.addVector(x, y, z));
+        return new HitResult(x, y, z, side, vec38.add(x, y, z));
     }
 
-    private boolean isVecInsideYZBounds(Vec3d vec3d)
+    private boolean isVecInsideYZBounds(Vec3 vec3)
     {
-        if(vec3d == null)
+        if(vec3 == null)
         {
             return false;
         }
         else
         {
-            return vec3d.yCoord >= minY && vec3d.yCoord <= maxY && vec3d.zCoord >= minZ && vec3d.zCoord <= maxZ;
+            return vec3.y >= minY && vec3.y <= maxY && vec3.z >= minZ && vec3.z <= maxZ;
         }
     }
 
-    private boolean isVecInsideXZBounds(Vec3d vec3d)
+    private boolean isVecInsideXZBounds(Vec3 vec3)
     {
-        if(vec3d == null)
+        if(vec3 == null)
         {
             return false;
         }
         else
         {
-            return vec3d.xCoord >= minX && vec3d.xCoord <= maxX && vec3d.zCoord >= minZ && vec3d.zCoord <= maxZ;
+            return vec3.x >= minX && vec3.x <= maxX && vec3.z >= minZ && vec3.z <= maxZ;
         }
     }
 
-    private boolean isVecInsideXYBounds(Vec3d vec3d)
+    private boolean isVecInsideXYBounds(Vec3 vec3)
     {
-        if(vec3d == null)
+        if(vec3 == null)
         {
             return false;
         }
         else
         {
-            return vec3d.xCoord >= minX && vec3d.xCoord <= maxX && vec3d.yCoord >= minY && vec3d.yCoord <= maxY;
+            return vec3.x >= minX && vec3.x <= maxX && vec3.y >= minY && vec3.y <= maxY;
         }
     }
 
@@ -460,12 +523,12 @@ public class Block
     {
     }
 
-    public int getRenderBlockPass()
+    public int getRenderLayer()
     {
         return 0;
     }
 
-    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, int side)
+    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side)
     {
         return canPlaceBlockAt(world, x, y, z);
     }
@@ -475,7 +538,7 @@ public class Block
     	return world.canPlaceInsideBlock(x, y, z);
     }
 
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         return false;
     }
@@ -484,27 +547,27 @@ public class Block
     {
     }
 
-    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
     }
 
-    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3d entityVelocity)
+    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
     }
-
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
     }
+
     public void setBlockBoundsBasedOnSide(WorldSource world, int x, int y, int z, Side side)
     {
     }
 
-    public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return false;
     }
 
-    public boolean canProvidePower()
+    public boolean isSignalSource()
     {
         return false;
     }
@@ -513,20 +576,15 @@ public class Block
     {
     }
 
-    public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
         return false;
     }
 
-    //Stub
-    public void setBlockBoundsForItemRender()
+    public void harvestBlock(World world, Player entityplayer, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-    }
+		entityplayer.addStat(getStat(StatList.STAT_MINED), 1);
 
-	public void harvestBlock(World world, EntityPlayer entityplayer, int x, int y, int z, int meta, TileEntity tileEntity)
-    {
-		entityplayer.addStat(StatList.mineBlockStatArray[id], 1);
-		
 		ItemStack heldItemStack = entityplayer.inventory.getCurrentItem();
 		Item heldItem = heldItemStack != null ? Item.itemsList[heldItemStack.itemID] : null;
 
@@ -534,13 +592,13 @@ public class Block
         {
             if (heldItem.isSilkTouch() && entityplayer.canHarvestBlock(this))
             {
-                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, tileEntity);
+                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, blockEntity);
                 return;
             }
-            else if (heldItem instanceof ItemToolShears && (this.hasTag(BlockTags.SHEARS_DO_SILK_TOUCH) || this.hasTag(BlockTags.MINEABLE_BY_SHEARS)))
+            else if (heldItem instanceof ToolShearsItem && (this.hasTag(BlockTags.SHEARS_DO_SILK_TOUCH) || this.hasTag(BlockTags.MINEABLE_BY_SHEARS)))
             {
-                ItemToolShears heldShears = (ItemToolShears) heldItem;
-                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, tileEntity);
+                ToolShearsItem heldShears = (ToolShearsItem) heldItem;
+                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, blockEntity);
                 heldShears.onBlockSheared(entityplayer, heldItemStack);
                 return;
             }
@@ -548,19 +606,24 @@ public class Block
 
         if (entityplayer.canHarvestBlock(this))
         {
-            dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, meta, tileEntity);
+            dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, meta, blockEntity);
         }
         else
         {
-            dropBlockWithCause(world, EnumDropCause.IMPROPER_TOOL, x, y, z, meta, tileEntity);
+            dropBlockWithCause(world, EnumDropCause.IMPROPER_TOOL, x, y, z, meta, blockEntity);
         }
 	}
 
-    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity)
+    @Nullable
+    public Stat getStat(String statID) {
+        return asItem().getStat(statID);
+    }
+
+    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if (world.isClientSide) return;
 
-        ItemStack[] drops = getBreakResult(world, cause, x, y, z, meta, tileEntity);
+        ItemStack[] drops = getBreakResult(world, cause, x, y, z, meta, blockEntity);
         if (dropOverride > 0){
             drops = new ItemStack[]{Item.itemsList[dropOverride].getDefaultStack()};
         }
@@ -570,7 +633,7 @@ public class Block
             {
                 if (drop != null)
                 {
-                	if(EntityItem.enableItemClumping)
+                	if(ItemEntity.enableItemClumping)
                 	{
                 		world.dropItem(x, y, z, drop.copy());
                 	}
@@ -581,7 +644,7 @@ public class Block
                         	ItemStack drop1 = drop.copy();
                         	drop1.stackSize = 1;
                             world.dropItem(x, y, z, drop1);
-                        }	
+                        }
                 	}
                 }
             }
@@ -592,11 +655,11 @@ public class Block
     {
         return true;
     }
-    
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	
+
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+
     }
-    
+
     public void setKey(String key)
     {
         this.key = "tile." + key;
@@ -620,7 +683,7 @@ public class Block
 
     public boolean getEnableStats()
     {
-        return enableStats;
+        return enableStats && getHardness() >= 0F;
     }
 
     public Block withDisabledStats()
@@ -681,16 +744,17 @@ public class Block
         if (block == null) return false;
         return block.hasTag(tag);
     }
-    
+
     public boolean isClimbable(World world, int x, int y, int z) {
     	return false;
     }
-    
+
+    @Nullable
     public static Block getBlock(int id)
     {
     	return blocksList[Math.max(id, 0)];
     }
-    
+
     public static Block getBlockByName(String name)
     {
     	Utils.requireNonNull(name);
